// [bg
#include "stdafx.h"
#include "G040425.h"

unsigned long		dwTmCount;		// Time Counter (free run)
int					iIndicator;		// Indicator Position 0`15
int					iBet[4];		// Bet 2,4,8,16
int					iMedal;			// Medal Count
int					iMedalBak;		// Medal Count Before
int					iRot[4];		// Rotational Count (100ms, 150ms, 300ms)
int					iSpk;			// Speeker ON/OFF
LPVOID				lpWav1;			// wave
//LPVOID				lpWav2;			// wave

struct position_t {
	int	iNo;
	int	iX;
	int	iY;
};
struct position_t stPos[] = {
	{  0, 3*20,      0   },				//  0

	{  2, 4*20+2,      4 },				//  1
	{  4, 5*20+2,   20-4 },				//  2
	{  2, 6*20-5, 2*20-6 },				//  3

	{  8, 6*20,   3*20-4 },				//  4

	{  2, 6*20-2, 4*20-2 },				//  5
	{  4, 5*20+9, 5*20-1 },				//  6
	{  2, 5*20-7, 6*20-6 },				//  7

	{ 16, 3*20+11, 6*20  },				//  8
	{  0, 3*20-11, 6*20  },				//  9

	{  2,   20+7, 6*20-6 },				// 10
	{  4,   20-9, 5*20-1 },				// 11
	{  2,      2, 4*20-2 },				// 12

	{  8,    0,   3*20-4 },				// 13

	{  2,      5, 2*20-6 },				// 14
	{  4,   20-2,   20-4 },				// 15
	{  2, 2*20-2,      4 }				// 16
};
#define INDCNT	17

struct position2_t {
	WORD wNo;
	int	iX;								// 
	int	iY;								// 
	int	iR;								// E
	int	iB;								// 
};
struct position2_t stBtn[] = {
	{  2,		   0, 152,  15, 167 },	// 0 [2]
	{  4,		  16, 152,  31, 167 },	// 1 [4]
	{  8,		  32, 152,  47, 167 },	// 2 [8]
	{ 16,		  48, 152,  63, 167 },	// 3 [16]
	{ VK_RETURN,   0, 170,  48, 195 },	// 4 [START]
	{ TEXT('0'),  48, 170,  63, 195 },	// 5 [CANCEL]
	{ TEXT('s'), 213,   2, 224,  14 },	// 6 [SPK]
	{ VK_ESCAPE, 225,   0, 240,  15 }	// 7 [X]
};

int iBetBtn;
int iBetBtnNo;
int iBtn;


extern HDC		hdcScreen;				// EChEXN[
extern HDC		hdcNum;					// LN^
extern HBITMAP	hBmpScreen;				// XN[prbg}bv
extern int		nWidth;					// EBhE
extern int		nLeft;					// \JnXW
extern int		nRight;					// \IXW
extern int		nBaseX;					// KCh\JnXW
extern int		nBaseY;					// KCh\JnYW
extern int		nRatio;					// ʃTCY{
extern WORD		wTapX;					// ^bvXW
extern WORD		wTapY;					// ^bvYW
extern WORD		wInKey;					// L[
extern WORD		wInKeyChg;				// ωL[


// 
void GmInitialize(void)
{
	int no;

	iIndicator = 0;						// ̈ʒu 0`15
	iMedal = 10;						// _10
	iBetBtn = OFF;
	iBtn = OFF;
	iSpk = OFF;

	stBtn[6].iX = nWidth/nRatio-29;
	stBtn[6].iR = nWidth/nRatio-18;
	stBtn[7].iX = nWidth/nRatio-16;
	stBtn[7].iR = nWidth/nRatio-1;

	for (no=0; no<4; no++) {
		iBet[no] = 0;					// q 0
	}
}

// 
void GmReset(void)
{
	int no;

	iMedal = 10;						// _10
	iBetBtn = OFF;
	iBtn = OFF;

	for (no=0; no<4; no++) {
		iBet[no] = 0;					// q 0
	}
}

// Q[bZ[W
void  GmMsgOut(TCHAR *msg)
{
	RECT rt;

	rt.left   = nLeft+35;
	rt.right  = nLeft+105;
	rt.top    = 71;
	rt.bottom = 111;
	DrawText(hdcScreen, msg, _tcslen(msg), &rt, DT_VCENTER | DT_CENTER);
}

// qv
// x : 0=[2], 1=[4], 2=[8], 3=[16]
// y : 1`5
void GmBetLamp(int x, int y, int sw)
{
	if (sw) {									// ON
		BitBlt(hdcScreen, stBtn[x].iX+nBaseX, stBtn[x].iY+nBaseY-8*y-2, 16, 9, 
				hdcNum, 0, 16, SRCCOPY);
	} else {									// OFF
		BitBlt(hdcScreen, stBtn[x].iX+nBaseX, stBtn[x].iY+nBaseY-8*y-2, 16, 9, 
				hdcNum, 0, 24, SRCCOPY);
	}
}

// q{^
// no : 0=[2], 1=[4], 2=[8], 3=[16]
void GmBetBtn(int no, int sw)
{
	int x, y;

	if (sw) {									// ON
		BitBlt(hdcScreen, stBtn[no].iX+nBaseX, stBtn[no].iY+nBaseY, 16, 16, 
				hdcNum, 16, 16, SRCCOPY);
		x = y = 1;
	} else {									// OFF
		BitBlt(hdcScreen, stBtn[no].iX+nBaseX, stBtn[no].iY+nBaseY, 16, 16, 
				hdcNum, 16, 32, SRCCOPY);
		x = y = 0;
	}
	
	if (stBtn[no].wNo < 10) {
		BitBlt(hdcScreen, stBtn[no].iX+nBaseX+4+x, stBtn[no].iY+nBaseY+2+y, 8, 12, 
				hdcNum, stBtn[no].wNo*8, 0, SRCAND);
	} else {
		BitBlt(hdcScreen, stBtn[no].iX+nBaseX+1+x,   stBtn[no].iY+nBaseY+2+y, 8, 12, 
				hdcNum, 1*8, 0, SRCAND);
		BitBlt(hdcScreen, stBtn[no].iX+nBaseX+7+x, stBtn[no].iY+nBaseY+2+y, 8, 12, 
				hdcNum, 6*8, 0, SRCAND);
	}
}

// START{^
void GmStartBtn(int sw)
{
	if (sw) {									// ON
		BitBlt(hdcScreen, stBtn[4].iX+nBaseX, stBtn[4].iY+nBaseY, 40, 16, 
				hdcNum, 120, 0, SRCCOPY);
	} else {									// OFF
		BitBlt(hdcScreen, stBtn[4].iX+nBaseX, stBtn[4].iY+nBaseY, 40, 16, 
				hdcNum, 120, 16, SRCCOPY);
	}
}

// CABCEL{^
void GmCancelBtn(int sw)
{
	if (sw) {									// ON
		BitBlt(hdcScreen, stBtn[5].iX+nBaseX, stBtn[5].iY+nBaseY, 16, 16, 
				hdcNum, 72, 16, SRCCOPY);
	} else {									// OFF
		BitBlt(hdcScreen, stBtn[5].iX+nBaseX, stBtn[5].iY+nBaseY, 16, 16, 
				hdcNum, 88, 16, SRCCOPY);
	}
}

// Q[TEh
void GmPlay(int no)
{
	if (iSpk == OFF) return;

	switch (no) {
	case 0:										// 0
		sndPlaySound(NULL, SND_MEMORY | SND_ASYNC | SND_NODEFAULT);
		break;
	case 1:										// 1
		sndPlaySound((LPCTSTR)lpWav1, SND_MEMORY | SND_ASYNC | SND_NOSTOP);
		break;
	case 2:										// 2
//		sndPlaySound((LPCTSTR)lpWav2, SND_MEMORY | SND_ASYNC | SND_NOSTOP);
		break;
	}
}

// SPK{^
void GmSpkBtn(int sw)
{
	if (sw) {								// ON
		if (iSpk) {
			iSpk = OFF;
		} else {
			iSpk = ON;
		}
	}
	if (iSpk) {								// ON
		BitBlt(hdcScreen, stBtn[6].iX, stBtn[6].iY, 12, 12, 
				hdcNum, 80, 0, SRCCOPY);
		GmPlay(1);
	} else {								// OFF
		BitBlt(hdcScreen, stBtn[6].iX, stBtn[6].iY, 12, 12, 
				hdcNum, 92, 0, SRCCOPY);
		GmPlay(0);
	}
}

// X{^
void GmEscBtn(int sw)
{
	if (sw) {									// ON
		BitBlt(hdcScreen, stBtn[7].iX, stBtn[7].iY, 16, 16, 
				hdcNum, 104, 0, SRCCOPY);
	} else {									// OFF
		BitBlt(hdcScreen, stBtn[7].iX, stBtn[7].iY, 16, 16, 
				hdcNum, 104, 16, SRCCOPY);
	}
}

// {^ON/OFF
void GmBtn(int no, int sw)
{
	switch (no) {
	case 0:
	case 1:
	case 2:
	case 3:
		GmBetBtn(no, sw);
		break;
	case 4:
		GmStartBtn(sw);
		break;
	case 5:
		GmCancelBtn(sw);
		break;
	case 6:
		GmSpkBtn(sw);
		break;
	case 7:
		GmEscBtn(sw);
		break;
	}
}

// {^
void GmBetBtnOn(int no)
{
	GmBtn(no, ON);
	iBetBtn = ON;
	iBetBtnNo = no;
}

// MEDAL
void GmDrawMedal(void)
{
	TCHAR szMsg[80];
	RECT rt;

	BitBlt(hdcScreen, nLeft, 170, 160, 16, hdcNum, 80, 32, SRCCOPY);

	wsprintf(szMsg, _T("%05d"), iMedal);
	rt.left   = nLeft+35;
	rt.right  = nLeft+45+8*5;
	rt.top    = 170+2;
	rt.bottom = 170+14;
	DrawText(hdcScreen, szMsg, _tcslen(szMsg), &rt, 
		DT_SINGLELINE | DT_VCENTER | DT_CENTER);
}

// q{^E^bv
// return : 0=[2], 1=[4], 2=[8], 3=[16], -1=non
int GmCheckBetBtn(void)
{
	int no;
	int x, y;

	x = wTapX - nBaseX;
	y = wTapY - nBaseY;
	for (no=0; no<4; no++) {
		if ((stBtn[no].iX < x) && (x < stBtn[no].iR) &&
			(stBtn[no].iY < y) && (y < stBtn[no].iB)) {

			wInKey = TEXT('1')+no;
			return no;
		}
	}
	return -1;
}

// ̑{^E^bv
// return : L[R[h
WORD GmCheckBtn(void)
{
	int no;
	int x, y;

	x = wTapX - nBaseX;
	y = wTapY - nBaseY;
	for (no=4; no<6; no++) {
		if ((stBtn[no].iX < x) && (x < stBtn[no].iR) &&
			(stBtn[no].iY < y) && (y < stBtn[no].iB)) {
			
			wInKey = stBtn[no].wNo;
			return stBtn[no].wNo;
		}
	}
	x = wTapX;
	y = wTapY;
	for (no=6; no<8; no++) {
		if ((stBtn[no].iX < x) && (x < stBtn[no].iR) &&
			(stBtn[no].iY < y) && (y < stBtn[no].iB)) {
				
			wInKey = stBtn[no].wNo;
			return stBtn[no].wNo;
		}
	}
	return 0;
}

// qǉ
void GmAddBet(int no)
{
	if (iMedal == 0) return;

	if (iBet[no] < 5) {
		iBet[no]++;
		GmBetLamp(no, iBet[no], ON);
		iMedal--;
		GmDrawMedal();

		// bZ[Wg
		GmMsgOut(_T("  READY  "));
	}
}

// qNA
void GmClearBet(void)
{
	int no;
	int y;

	for (no=0; no<4; no++) {
		iMedal += iBet[no];
		iBet[no] = 0;
		for (y=1; y<=5; y++) {
			GmBetLamp(no, y, OFF);
		}
	}
}

// ߂zvZ
void GmReturnBet(void)
{
	int no;
	int rate;
	int rtn;
	TCHAR szMsg[80];

	rtn = 0;
	rate = stPos[iIndicator].iNo;
	if (rate) {
		for (no=0; no<4; no++) {
			if (stBtn[no].wNo == rate) break;
		}
		rtn = iBet[no] * rate;
		iMedal += rtn;
	}
	if (rtn) {
		wsprintf(szMsg, _T(" Get! %02d "), rtn);
	} else {
		wsprintf(szMsg, _T(" lost  "));
	}
	GmMsgOut(szMsg);

	for (no=0; no<4; no++) {
		iBet[no] = 0;
	}
}

// _
void GmLight(int no, int sw)
{
	// BOX̕`
	if (sw) {									// ON
		BitBlt(hdcScreen, stPos[no].iX+nLeft, stPos[no].iY+24, 20, 20, 
				hdcNum, 20, 48, SRCAND);
	} else {									// OFF
		BitBlt(hdcScreen, stPos[no].iX+nLeft, stPos[no].iY+24, 20, 20, 
				hdcNum, 40, 48, SRCPAINT);
	}
	
	if (stPos[no].iNo < 10) {
		BitBlt(hdcScreen, stPos[no].iX+nLeft+6, stPos[no].iY+24+4, 8, 12, 
				hdcNum, stPos[no].iNo*8, 0, SRCAND);
	} else {
		BitBlt(hdcScreen, stPos[no].iX+nLeft+2, stPos[no].iY+24+4, 8, 12, 
				hdcNum, 1*8, 0, SRCAND);
		BitBlt(hdcScreen, stPos[no].iX+nLeft+9, stPos[no].iY+24+4, 8, 12, 
				hdcNum, 6*8, 0, SRCAND);
	}
}

// {ʍ쐬
void GmMakeBack(void)
{
	int no;

	// BOX̕`
	for (no=0; no<INDCNT; no++) {
		GmLight(no, OFF);
	}
	GmLight(iIndicator, ON);

	// BET
	int y;
	for (no=0; no<4; no++) {
		for (y=1; y<=5; y++) {
			GmBetLamp(no, y, OFF);
		}

		GmBetBtn(no, OFF);
	}

	// START
	GmStartBtn(OFF);
	GmCancelBtn(OFF);
	GmSpkBtn(OFF);						// OFF:Olێŕ\
	GmEscBtn(OFF);
	GmDrawMedal();
}

// I[vjO
static int GmState0(int *state)
{
	static int cnt = 10;

	if (cnt++ > 9) {
		cnt = 0;
		GmLight(iIndicator, OFF);
		iIndicator++;
		if (iIndicator >= INDCNT) {
			iIndicator = 0;
		}
		GmLight(iIndicator, ON);
	}

	switch (wInKeyChg) {
	case VK_ESCAPE:
		GmBetBtnOn(7);
		return -1;
	case TEXT('s'):					// [s]
		GmBetBtnOn(6);
		break;
	case VK_RETURN:
	case VK_SPACE:
		GmReset();
		GmMakeBack();
		GmBetBtnOn(4);
		GmMsgOut(_T("  SELECT  "));
		(*state)++;
		break;
	case TEXT('1'):
	case TEXT('2'):
	case TEXT('3'):
	case TEXT('4'):
		GmReset();
		GmMakeBack();
		GmBetBtnOn(wInKeyChg - TEXT('1'));
		GmMsgOut(_T("  SELECT  "));
		(*state)++;
		break;
	}
	return 0;
}

// q
static int GmState1(int *state)
{
	static int cnt = 10;
	int no;
	int res;

	cnt = (cnt+1) & 0x7FFF;

	switch (wInKeyChg) {
	case VK_ESCAPE:
		GmBetBtnOn(7);
		return -1;
	case TEXT('S'):					// [s]
	case TEXT('s'):					// [s]
		GmBetBtnOn(6);
		break;
	case VK_RETURN:					// [START]
	case VK_SPACE:
		GmBetBtnOn(4);
		res = iBet[0];
		for (no=1; no<4; no++) {
			res += iBet[no];
		}
		if (res > 0) {
			srand(cnt+iIndicator);
			GmMsgOut(_T("  START  "));
			(*state)++;
		}
		break;
	case TEXT('0'):					// [CANCEL]
		GmBetBtnOn(5);
		GmClearBet();
		GmDrawMedal();
		break;
	case TEXT('1'):					// [2]
	case TEXT('2'):					// [4]
	case TEXT('3'):					// [8]
	case TEXT('4'):					// [16]
		GmBetBtnOn(wInKeyChg - TEXT('1'));
		GmAddBet(wInKeyChg - TEXT('1'));
		break;
	}

	return 0;
}

// [bg]
static int GmState2(int *state)
{
	static int st = 0;
	static int cnt;
	static int tim;

	switch (st) {
	case 0:
		cnt = 0;
		tim = 0;
		iRot[0] = Random() % 10 + 20;
		iRot[1] = iRot[0] + Random() % 10 + 20;
		iRot[2] = iRot[1] + Random() % 10 + 40;
		iRot[3] = iRot[2] + 36;
		st++;
		break;

	case 1:
		GmLight(iIndicator, OFF);
		iIndicator++;
		if (iIndicator >= INDCNT) {
			iIndicator = 0;
		}
		GmLight(iIndicator, ON);
		GmPlay(1);
		
		if (cnt++ > iRot[tim]) {
			tim++;
			st++;
		}
		break;

	case 2:
		if (cnt % 2 == 0) {
			GmLight(iIndicator, OFF);
			iIndicator++;
			if (iIndicator >= INDCNT) {
				iIndicator = 0;
			}
			GmLight(iIndicator, ON);
			GmPlay(1);
		}
		
		if (cnt++ > iRot[tim]) {
			tim++;
			st++;
		}
		break;

	case 3:
		if (cnt % 4 == 0) {
			GmLight(iIndicator, OFF);
			iIndicator++;
			if (iIndicator >= INDCNT) {
				iIndicator = 0;
			}
			GmLight(iIndicator, ON);
			GmPlay(1);
			GmMsgOut(_T("          "));
		}
		
		if (cnt++ > iRot[tim]) {
			tim++;
			st++;
			GmReturnBet();
		}
		break;

	case 4:
		if (cnt % 6 == 0) {
			GmLight(iIndicator, ON);
			GmPlay(1);
		} else if (cnt % 3 == 0) {
			GmLight(iIndicator, OFF);
		}
		
		if (cnt++ > iRot[tim]) {
			st = 0; 
			(*state)++;
		}
		break;
	}
	return 0;
}

// [bg~
static int GmState3(int *state)
{
	GmMakeBack();

	if (iMedal == 0) {
		GmMsgOut(_T(" GameOver "));
		*state = 0;
	} else {
		*state = 1;
	}

	return 0;
}

// Q[C
// 100mSɌĂяo
int GmMain(int *state)
{
	if (iBetBtn == ON) {
		iBetBtn = OFF;
		GmBtn(iBetBtnNo, OFF);
	}

	switch (*state) {
	case 0:					// I[vjO
		return GmState0(state);
	case 1:					// q
		return GmState1(state);
		break;
	case 2:					// [bg]
		return GmState2(state);
		break;
	case 3:					// [bg~
		return GmState3(state);
		break;
	}

	return 0;
}
